<?php

namespace Drupal\cmlmigrations\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Controller routines for page example routes.
 */
class FindImage extends ControllerBase {

  /**
   * Find variations.
   */
  public static function getBy1cImage($image = 'import_files', $all = TRUE) {
    $images = [];

    if ($image || $all) {
      $query = \Drupal::database()->select('file_managed', 'files')
        ->fields('files', [
          'fid',
          'uri',
        ])
        ->condition('uri', "%$image%", 'LIKE')
        ->condition('status', 1);
      $res = $query->execute();

      if ($res) {
        foreach ($res as $file) {
          $uri = strstr($file->uri, 'import_files');
          $fid = $file->fid;
          $images[$uri] = $fid;
        }
      }
    }
    return $images;
  }

}
