<?php

namespace Drupal\cmlmigrations\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\HtmlCommand;
use Drupal\cmlmigrations\Controller\MigrationsExec;

/**
 * Implements ExecMigrations.
 */
class ExecMigrations extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'cmlmigrations_exec';
  }

  /**
   * AJAX Responce.
   */
  public static function ajax($otvet) {
    $response = new AjaxResponse();
    $response->addCommand(new HtmlCommand("#exec-results", "<pre>{$otvet}</pre>"));
    return $response;
  }

  /**
   * AJAX Import.
   */
  public static function ajaxImport(array $form, FormStateInterface $form_state) {
    $otvet = "ajaxImport\n";
    $otvet .= MigrationsExec::exec('exec', FALSE);
    return self::ajax($otvet);
  }

  /**
   * AJAX Update.
   */
  public static function ajaxUpdate(array $form, FormStateInterface $form_state) {
    $otvet = "ajaxUpdate\n";
    $otvet .= MigrationsExec::exec('exec', TRUE);
    return self::ajax($otvet);
  }

  /**
   * AJAX Test Exec.
   */
  public static function ajaxTestExec(array $form, FormStateInterface $form_state) {
    $otvet = "ajaxTestExec\n";
    $otvet .= MigrationsExec::exec('debug', TRUE);
    return self::ajax($otvet);
  }

  /**
   * AJAX Test Drush.
   */
  public static function ajaxTestDrush(array $form, FormStateInterface $form_state) {
    $otvet = "ajaxUpdate\n";
    $otvet .= MigrationsExec::exec('drush', TRUE);
    return self::ajax($otvet);
  }

  /**
   * AJAX Test Nohup.
   */
  public static function ajaxTestNohup(array $form, FormStateInterface $form_state) {
    $otvet = "ajaxTestNohup\n";
    $otvet .= MigrationsExec::exec('nohup', TRUE);
    return self::ajax($otvet);
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state, $extra = NULL) {
    $form_state->setCached(FALSE);

    $form['info'] = [
      '#markup' => '<h3>Запустить:</h3>',
    ];
    $form['actions'] = [
      '#type' => 'actions',
      'import' => [
        '#type' => 'submit',
        '#value' => 'Import',
        '#ajax'   => [
          'callback' => '::ajaxImport',
          'effect'   => 'fade',
          'progress' => ['type' => 'throbber', 'message' => ""],
        ],
      ],
      'update' => [
        '#type' => 'submit',
        '#value' => 'Update',
        '#ajax'   => [
          'callback' => '::ajaxUpdate',
          'effect'   => 'fade',
          'progress' => ['type' => 'throbber', 'message' => ""],
        ],
      ],
      'test-exec' => [
        '#type' => 'submit',
        '#value' => 'TestExec',
        '#ajax'   => [
          'callback' => '::ajaxTestExec',
          'effect'   => 'fade',
          'progress' => ['type' => 'throbber', 'message' => ""],
        ],
      ],
      'test-drush' => [
        '#type' => 'submit',
        '#value' => 'TestDrush',
        '#ajax'   => [
          'callback' => '::ajaxTestDrush',
          'effect'   => 'fade',
          'progress' => ['type' => 'throbber', 'message' => ""],
        ],
      ],
      'test-nohup' => [
        '#type' => 'submit',
        '#value' => 'TestNohup',
        '#ajax'   => [
          'callback' => '::ajaxTestNohup',
          'effect'   => 'fade',
          'progress' => ['type' => 'throbber', 'message' => ""],
        ],
      ],
      '#suffix' => '<div id="exec-results"></div>',
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {

  }

}
