<?php

namespace Drupal\cmlmigrations\Hook;

/**
 * @file
 * Contains \Drupal\cmlmigrations\Controller\EntityView.
 */

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlmigrations\Controller\FindVariation;

/**
 * Hook insert.
 */
class CommerceProductInsert extends ControllerBase {

  /**
   * Hook.
   */
  public static function hook($product) {
    // Fix variation on insert.
    $id1c = $product->uuid->value;
    $variations = FindVariation::getBy1cUuid($id1c);
    if (isset($variations[$id1c])) {
      $product->variations->setValue($variations[$id1c]);
    }
    $product->save();
  }

}
